#pragma once

#include "stdafx.h"

class ExecutionCommand
{
public:
	

	void       setTarget(ActualCommandParams actualCommandParams);
	void       callFunc(ActualCommandParams actualCommandParams);

	void       setDataBlock(DataBlock dataBlock);
	DataBuffer retDataBuffer();

	void       initVerbose();
	bool       retVerbose();

	uint32_t   retNumResponseBytes();
	uint32_t   retNewBaudRate();
	bool       retRunFunc();

private:
	bool       runFunc;
	std::unique_ptr<InterfaceTarget> target;
	DataBuffer dataBuffer;
	
};

class ExecutionCommunication
{
public:

	void     setTarget(ActualCommandParams actualCommandParams);
	void     init(ActualCommandParams actualCommandParams);
	void     transmitBuffer(DataBuffer dataBuffer, bool verbose);
	void     transmitBufferInit432();
	uint8_t* receiveBuffer(uint32_t size, bool verbose);
	void     close();

	void     changeBaudRate(uint32_t baudRate);

	uint32_t retBytesWritten();
	uint32_t retBytesRead();
	void     resetBytesWritten();
	void     resetBytesRead();

private:

	std::unique_ptr<InterfaceCommunication> targetComm;
};

