#pragma once

#include "stdafx.h"

using namespace std;

class ScripterStream
{
public:

	//Constructor
	ScripterStream();

	//Public Variable
	uint8_t numOfLines;
	
	//Scripter streaming task
	std::string startScripter(char * ch);
	bool        getLine();
	std::string retStringCommand();
	
	//Reading file
	void      initReadTxtFile(ActualCommandParams actualCommandParams, std::string mainPathDir);
	void      readTxtFile();
	DataBlock retDataBlockRead();

	uint8_t retReadStatus();
	uint8_t retSendStatus();
	void    closeReadTxtFile();

	//Writing file
	void initWriteTxtFile(ActualCommandParams actualCommandParams, std::string mainPathDir);
	void writeTxtFile(uint8_t *buf, uint32_t size);
	void closeWriteTxtFile();

private:

	//Streaming scripter
	std::string   fileScriptName;
	std::ifstream fileScriptStream;
	std::string   line;

	//File pointer for reading and writing
	std::string   fileName;

	//Writing task
	std::ofstream    fileWriteStream;
	std::string intToHex(uint8_t input);
	std::string intToHexAddr(uint32_t address);
	
	uint32_t    maxBufSize ;
	uint8_t     startHeader1;
	uint8_t     startHeader2 ;
	uint32_t    minTempSize;
	//Reading task
	ifstream  fileReadStream;
	uint16_t  bytesRead;
	DataBlock dataBlockRead;
	uint32_t  saveLastReadAddress;
	uint16_t  numBytesToRead;
	
	const uint8_t READ_ON_GOING = 1;
	const uint8_t READ_DONE = 0;
	uint8_t       readStatus;

	const uint8_t CHANGE_ADDRESS = 0x01;
	const uint8_t NO_CHANGE_ADDRESS = 0x00;
	uint8_t       changeAddress;

	const uint8_t SEND_DATA_BLOCK = 1;
	const uint8_t KEEP_DATA_BLOCK = 0;
	uint8_t       sendStatus;

	void setSendStatus();
	void clearSendStatus();
	void onGoingReadStatus();
	void finishReadStatus();

	std::string getThePathFile(std::string stInput, std::string relativePath);
};


