#pragma once

#include "stdafx.h"
#include "hidapi.h"
#include "DataType.h"

class UsbComm : public InterfaceCommunication
{
public:

	UsbComm();
	void init(ActualCommandParams actualCommandParams) override;
	void transmitBuffer(DataBuffer dataBlock, bool verbose) override;
	void transmitBufferInit432() override;
	uint8_t* receiveBuffer(uint32_t size, bool verbose) override;
	void close() override;

	void changeBaudRate(uint32_t baudRate) override;

	uint32_t   retBytesWritten() override;
	uint32_t   retBytesRead() override;
	void       resetBytesWritten() override;
	void       resetBytesRead() override;

private:

	void cleanBigBuffer()
	{
		for (uint16_t i = 0; i < 20; i++)
		{
			bigBuffer[i] = 0;
		}
	}


	const uint32_t MS_DELAY_RX = 50;
	const uint16_t VID = 0x2047; //BSL Device
	const uint16_t PID = 0x0200;// BSL device

	hid_device *handle;

	uint8_t bigBuffer[0xFFFF];

	string intToHex(uint8_t input)
	{
		std::stringstream stream;
		stream << std::setfill('0')
			<< std::setw(sizeof(input) * 2)
			<< std::hex
			<< (uint32_t)input;
		return stream.str();
	}

	uint32_t bytesRead;
	uint32_t bytesWrite;
};

